local FE = ...

for key,value in pairs(FCconfig["profile"]["resources"]) do
	FE:register({
		DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
		Id = "FE_BUILDING_FUNCTION_INFINITE_"..key,
		Name = "FE_BUILDING_FUNCTION_INFINITE_"..key.."_NAME",
		ResourceGenerated = key,
		IsForConsumer = true,
		IsInfinite = true
	})
end

for key,value in pairs(FCconfig["profile"]["buildings"]) do
	if (value["buildingParts"] ~= nill) then
		for key,value in pairs (value["buildingParts"]) do
			local t={}
			local st=""
			local c = 0
			local fListT = {}
			local gfListT ={}
        		for str in string.gmatch(key, "([^_]+)") do
                		table.insert(t, str)
        		end
			for key,value in pairs(t) do 
				if (c > 1) then
					st = st.."_"..value
				end
				c = c + 1
			end
			if (value["buildingFunction"] ~= nill) then
				for key,value in pairs(value["buildingFunction"]["functionList"]) do
					if (value) then
						table.insert(fListT, key)
					end
				end
				for key,value in pairs(FCconfig["profile"]["buildingFunctions"]["functionList"]) do
					if (value) then
						table.insert(gfListT, key)
					end
				end
				if (value["buildingFunction"]["useGlobalList"])then
					FE:register({
						DataType = "BUILDING_FUNCTION_LIST",
						Id = "FE_BUILDING_FUNCTION_LIST"..st,
						AssetFunctionList = gfListT
					})
				else
					FE:register({
						DataType = "BUILDING_FUNCTION_LIST",
						Id = "FE_BUILDING_FUNCTION_LIST"..st,
						AssetFunctionList = fListT
					})
				end
				FE:register({
					DataType = "BUILDING_FUNCTION_ASSIGNABLE",
					Id = "FE_BUILDING_FUNCTION_ASSIGNABLE"..st,
					Name = "FE_BUILDING_FUNCTION_ASSIGNABLE"..st.."_NAME",
					AuthorizedFunctionList = "FE_BUILDING_FUNCTION_LIST"..st
				})
				FE:override({
					Id = key,
					BuildingFunction = value["buildingFunction"]["activeFunction"]
				})
			end
		end
	end
end

local vanillaFunctionList = {"BUILDING_FUNCTION_BAKERY","BUILDING_FUNCTION_BEEKEEPING","BUILDING_FUNCTION_BERRY_TABLE","BUILDING_FUNCTION_BLACKSMITH","BUILDING_FUNCTION_CHEESE_MAKER","BUILDING_FUNCTION_COAL_HUT","BUILDING_FUNCTION_COOPERAGE","BUILDING_FUNCTION_FORESTER","BUILDING_FUNCTION_HERBS_GARDEN","BUILDING_FUNCTION_HUNTERS_HUT","BUILDING_FUNCTION_IRON_MINE","BUILDING_FUNCTION_IRON_SMELTER","BUILDING_FUNCTION_SAWMILL","BUILDING_FUNCTION_STONECUTTER_CAMP","BUILDING_FUNCTION_STONEMASON_HUT","BUILDING_FUNCTION_TAILOR_WORKSHOP","BUILDING_FUNCTION_WEAPONSMITH","BUILDING_FUNCTION_WEAVER_HUT","BUILDING_FUNCTION_WINDMILL","BUILDING_FUNCTION_WINERY","BUILDING_FUNCTION_WOODCUTTER","BUILDING_FUNCTION_WHEAT_FARM","BUILDING_FUNCTION_FISHING_HUT","BUILDING_FUNCTION_KITCHEN","BUILDING_FUNCTION_DAIRY_FARM","BUILDING_FUNCTION_SHEEP_FARM","BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM","BUILDING_FUNCTION_WELL","BUILDING_FUNCTION_WOODEN_KEEP","BUILDING_FUNCTION_GRANARY","BUILDING_FUNCTION_WAREHOUSE"}
for key,value in pairs(vanillaFunctionList) do
	FE:override({
		Id = value,
		Name = "VANILLA_"..value.."_NAME"
	})
end